uniform sampler2D tex;
uniform sampler2D refTex;

varying vec3 vSrcA;
varying vec3 vTrgA;

void main(void) {    
    vec4 base = texture2D(tex, floor(gl_TexCoord[0].st) / 1024.0);
    vec4 ref = texture2D(refTex, floor(gl_TexCoord[0].st) / 1024.0);
    if ((ref.x - vSrcA.x) * (ref.x - vSrcA.x) + (ref.y - vSrcA.y) * (ref.y - vSrcA.y) + (ref.z - vSrcA.z) * (ref.z - vSrcA.z) < 0.000256) {
        base.xyz = vTrgA;
    }
	gl_FragColor = base * gl_Color;
}
